#ifndef CYOA_H
#define CYOA_H

#include <vector>
#include <map>

#define STATCHECK_GT 1
#define STATCHECK_LT 2

struct statcheck_t {
  char *stat;
  int value;
  int rel;
};

struct statchange_t {
  char *stat;
  int addend;
};

struct Choice {
  int option;
  char *flavor;
  statcheck_t *statcheck;
  char *id;
  statchange_t *statchange;

  Choice(int);
};

typedef std::map<int, Choice*> ChoiceList;

enum class FooterType {
  End,
  Goto,
  Choices
};

struct Footer {
  FooterType type;
  union {
    ChoiceList *choices;
    char *link;
  };

  Footer();
  ~Footer();
};

struct Page {
  char *id;
  char *body;
  Footer footer;

  Page();
  ~Page();
};

std::vector<Page*> CyoaParse(FILE *);

#endif /* CYOA_H */

// Local Variables:
// mode: c++
// End:
